-- Dozenal Time Hands

-- 1 day = 12 hours
-- 1 hour = 12 minutes
-- 1 minute = 12 seconds
-- 1 second = 12 terces
-- 1 terc = 1/20736th of a day

local hands = {}

hands.dots = {}
for i=1,144 do
	local d = {
		angle = (((math.pi * 2) / 144) * i) + (math.pi / 2)
	}
	d.o = 12
	d.i = 8
	d.x = ((radius / 12) * 8) * math.cos(d.angle) + (screen.width / 2)
	d.y = ((radius / 12) * 8) * math.sin(d.angle) + (screen.height / 2)
	d.reach = (i % 12 == 0) and 0.015 or ((i % 6 == 0) and 0.008 or 0.00375)
	d.radius = (i % 12 == 0) and radius * 0.015 or ((i % 6 == 0) and radius * 0.008 or radius * 0.00375)
	d.color = {127,127,127}
	hands.dots[#hands.dots + 1] = d
end

hands.dots.drawinfo = function(self,t)

	local dh = tostring(math.floor(t / 7200) % 12)
	local dm = tostring(math.floor((t / 600) % 12))
	local ds = tostring(math.floor((t / 50)) % 12)
	local du = tostring(math.floor((t / 4.16666666666667) % 12))
	local dv = tostring(math.floor((t / 0.34722222222222) % 12))

	if dh == '10' then dh = 'X' elseif dh == '11' then dh = 'E' end
	if dm == '10' then dm = 'X' elseif dm == '11' then dm = 'E' end
	if ds == '10' then ds = 'X' elseif ds == '11' then ds = 'E' end
	if du == '10' then du = 'X' elseif du == '11' then du = 'E' end
	if dv == '10' then dv = 'X' elseif dv == '11' then dv = 'E' end

	-- duodecimal time
	love.graphics.print(
		dh .. dm .. ds .. '.' .. du .. dv,
		screen.width / 2 - love.graphics.getFont():getWidth(dh .. '_' .. dm .. '.' .. ds .. ',' .. du) / 2, 
		screen.height / 2 + love.graphics.getFont():getHeight() * 20 * (radius / 1000)
	)
end

-- terces
hands[1] = {
	color = {192,224,0},
	reach = 5.25/8,
	angle = 0,
	x = 0,
	y = 0,
	update = function(self,dt)
		self.angle = ((math.pi * 2) /  144) * ((dt*12) / (50/12)%144)
		           + ( math.pi / 2)
		self.x, self.y = calcCoords(self)
	end,
	draw = function(self)
		love.graphics.setColor(self.color)
		love.graphics.setLineWidth(1)
		love.graphics.line(screen.width / 2, screen.height / 2, self.x, self.y)
	end,
}

-- seconds
hands[2] = {
	color = {224,64,24},
	reach = 4.5/8,
	angle = 0,
	x = 0,
	y = 0,
	update = function(self,dt)
		self.angle = ((math.pi * 2) / 144) * (math.floor(dt / (50/12))%144)
		           + ( math.pi / 2)
		self.x, self.y = calcCoords(self)
	end,
	draw = function(self)
		love.graphics.setColor(self.color)
		love.graphics.setLineWidth(1)
		love.graphics.line(screen.width / 2, screen.height / 2, self.x, self.y)
	end,
}

-- minutes
hands[3] = {
	color = {128,164,0},
	reach = 3.75/8,
	angle = 0,
	x = 0,
	y = 0,
	-- seconds, though lose the modulo, and it would update constantly
	update = function(self,dt)
		self.angle = ((math.pi * 2) / 144) * (math.floor(dt / (600/12))%144)
		           + ( math.pi / 2)
		self.x, self.y = calcCoords(self)
	end,
	draw = function(self)
		love.graphics.setColor(self.color)
		love.graphics.setLineWidth(1)
		love.graphics.line(screen.width / 2, screen.height / 2, self.x, self.y)
	end,
}

-- hours
hands[4] = {
	color = {192,128,0},
	reach = 2.5/8,
	angle = 0,
	x = 0,
	y = 0,
	update = function(self,dt)
		self.angle = (( math.pi * 2) / 24)      * (math.floor(dt / 3600))
				   + (  math.pi / 2)
				   --+ (( math.pi * 2) / 24 / 12) * (math.floor(dt / 600)%12     )
		self.x, self.y = calcCoords(self)
	end,
	draw = function(self)
		love.graphics.setColor(self.color)
		love.graphics.setLineWidth(2)
		love.graphics.line(screen.width / 2, screen.height / 2, self.x, self.y)
	end,
}

return hands