-- Mayan vigesimal (base20) clock hands

-- 〇 for zero
-- ￮ for ones
-- 一 for fives

local hands = {}

hands.dots = {}
for i=1,20 do
	local d = {
		angle = (((math.pi * 2) / 20) * i) - (math.pi / 2)
	}
	d.o = 12
	d.i = 5.5
	d.x = ((radius / 12) * 5.5) * math.cos(d.angle) + (screen.width / 2)
	d.y = ((radius / 12) * 5.5) * math.sin(d.angle) + (screen.height / 2)
	d.reach = (i % 5 == 0) and 0.02 or 0.01
	d.radius = (i % 5 == 0) and radius * 0.02 or radius * 0.01
	d.color = {127,127,127}
	hands.dots[#hands.dots + 1] = d
end

hands.dots.drawinfo = function(self,t)

	local vh = tostring(math.floor(t / 4320) % 20)
	local vm = tostring(math.floor(t /  216) % 20)
	local vs = tostring(math.floor(t / 10.8) % 20)
	local vu = tostring(math.floor(t / 0.54) % 20)

	local h1,h2,h3,h4 = '','','',''
	if math.floor(vh / 5) == 3 then h4 = '——' end
	if math.floor(vh / 5) >= 2 then h3 = '——' end
	if math.floor(vh / 5) >= 1 then h2 = '——' end
	if math.floor(vh % 20) == 0 then h3 = 'O'
	else
		for i=1,4 do
			if vh%5 >= i then h1 = h1 .. '·' end
		end
	end

	local m1,m2,m3,m4 = '','','',''
	if math.floor(vm / 5) == 3 then m4 = '——' end
	if math.floor(vm / 5) >= 2 then m3 = '——' end
	if math.floor(vm / 5) >= 1 then m2 = '——' end
	if math.floor(vm % 20) == 0 then m3 = 'O'
	else
		for i=1,4 do
			if vm%5 >= i then m1 = m1 .. '·' end
		end
	end

	local s1,s2,s3,s4 = '','','',''
	if math.floor(vs / 5) == 3 then s4 = '——' end
	if math.floor(vs / 5) >= 2 then s3 = '——' end
	if math.floor(vs / 5) >= 1 then s2 = '——' end
	if math.floor(vs % 20) == 0 then s3 = 'O'
	else
		for i=1,4 do
			if vs%5 >= i then s1 = s1 .. '·' end
		end
	end

	local u1,u2,u3,u4 = '','','',''
	if math.floor(vu / 5) == 3 then u4 = '——' end
	if math.floor(vu / 5) >= 2 then u3 = '——' end
	if math.floor(vu / 5) >= 1 then u2 = '——' end
	if math.floor(vu % 20) == 0 then u3 = 'O'
	else
		for i=1,4 do
			if vu%5 >= i then u1 = u1 .. '·' end
		end
	end

	-- time
	love.graphics.print(
		h1,
		screen.width / 2 - love.graphics.getFont():getWidth(h1) / 2, 
		screen.height / 2 + love.graphics.getFont():getHeight() * (14) * (radius / 1000)
	)
	love.graphics.print(
		h2,
		screen.width / 2 - love.graphics.getFont():getWidth(h2) / 2, 
		screen.height / 2 + love.graphics.getFont():getHeight() * (16) * (radius / 1000)
	)
	love.graphics.print(
		h3,
		screen.width / 2 - love.graphics.getFont():getWidth(h3) / 2, 
		screen.height / 2 + love.graphics.getFont():getHeight() * (18) * (radius / 1000)
	)
	love.graphics.print(
		h4,
		screen.width / 2 - love.graphics.getFont():getWidth(h4) / 2, 
		screen.height / 2 + love.graphics.getFont():getHeight() * (20) * (radius / 1000)
	)
	love.graphics.print(
		m1,
		screen.width / 2 - love.graphics.getFont():getWidth(m1) / 2, 
		screen.height / 2 + love.graphics.getFont():getHeight() * (24) * (radius / 1000)
	)
	love.graphics.print(
		m2,
		screen.width / 2 - love.graphics.getFont():getWidth(m2) / 2, 
		screen.height / 2 + love.graphics.getFont():getHeight() * (26) * (radius / 1000)
	)
	love.graphics.print(
		m3,
		screen.width / 2 - love.graphics.getFont():getWidth(m3) / 2, 
		screen.height / 2 + love.graphics.getFont():getHeight() * (28) * (radius / 1000)
	)
	love.graphics.print(
		m4,
		screen.width / 2 - love.graphics.getFont():getWidth(m4) / 2, 
		screen.height / 2 + love.graphics.getFont():getHeight() * (30) * (radius / 1000)
	)
	love.graphics.print(
		s1,
		screen.width / 2 - love.graphics.getFont():getWidth(s1) / 2, 
		screen.height / 2 + love.graphics.getFont():getHeight() * (34) * (radius / 1000)
	)
	love.graphics.print(
		s2,
		screen.width / 2 - love.graphics.getFont():getWidth(s2) / 2, 
		screen.height / 2 + love.graphics.getFont():getHeight() * (36) * (radius / 1000)
	)
	love.graphics.print(
		s3,
		screen.width / 2 - love.graphics.getFont():getWidth(s3) / 2, 
		screen.height / 2 + love.graphics.getFont():getHeight() * (38) * (radius / 1000)
	)
	love.graphics.print(
		s4,
		screen.width / 2 - love.graphics.getFont():getWidth(s4) / 2, 
		screen.height / 2 + love.graphics.getFont():getHeight() * (40) * (radius / 1000)
	)
	love.graphics.print(
		u1,
		screen.width / 2 - love.graphics.getFont():getWidth(u1) / 2, 
		screen.height / 2 + love.graphics.getFont():getHeight() * (44) * (radius / 1000)
	)
	love.graphics.print(
		u2,
		screen.width / 2 - love.graphics.getFont():getWidth(u2) / 2, 
		screen.height / 2 + love.graphics.getFont():getHeight() * (46) * (radius / 1000)
	)
	love.graphics.print(
		u3,
		screen.width / 2 - love.graphics.getFont():getWidth(u3) / 2, 
		screen.height / 2 + love.graphics.getFont():getHeight() * (48) * (radius / 1000)
	)
	love.graphics.print(
		u4,
		screen.width / 2 - love.graphics.getFont():getWidth(u4) / 2, 
		screen.height / 2 + love.graphics.getFont():getHeight() * (50) * (radius / 1000)
	)
end

-- sub-seconds
hands[1] = {
	color = {4, 19, 64},
	reach = 3.7/8,
	angle = 0,
	x = 0,
	y = 0,
	update = function(self,dt)
		self.angle = ((math.pi * 2) / 20) * (dt / 0.54)
		           - (math.pi / 2)
		self.x, self.y = calcCoords(self)
	end,
	draw = function(self)
		love.graphics.setColor(self.color)
		love.graphics.setLineWidth(1)
		love.graphics.line(screen.width / 2, screen.height / 2, self.x, self.y)
	end,
}

-- seconds
hands[2] = {
	color = {48,64,16},
	reach = 3.5/8,
	angle = 0,
	x = 0,
	y = 0,
	-- seconds, though lose the modulo, and it would update constantly
	update = function(self,dt)
		self.angle = ((math.pi * 2) / 20) * (math.floor((dt / 10.8) % 100))
		           - (math.pi / 2)
		self.x, self.y = calcCoords(self)
	end,
	draw = function(self)
		love.graphics.setColor(self.color)
		love.graphics.setLineWidth(1)
		love.graphics.line(screen.width / 2, screen.height / 2, self.x, self.y)
	end,
}

-- minutes
hands[3] = {
	color = {144,186,16},
	reach = 3/8,
	angle = 0,
	x = 0,
	y = 0,
	update = function(self,dt)
		self.angle = ((math.pi * 2) / 20) * (math.floor(dt / 216))
		           - (math.pi / 2)
		self.x, self.y = calcCoords(self)
	end,
	draw = function(self)
		love.graphics.setColor(self.color)
		love.graphics.setLineWidth(1)
		love.graphics.line(screen.width / 2, screen.height / 2, self.x, self.y)
	end,
}

-- hours
hands[4] = {
	color = {224,164,0},
	reach = 2/8,
	angle = 0,
	x = 0,
	y = 0,
	update = function(self,dt)
		self.angle = (( math.pi * 2) / 20)       * (math.floor(dt / 4320)     )
				   - (  math.pi / 2)
				   --+ (((math.pi * 2) / 12) / 60) * (math.floor(dt /   60) % 60)
		self.x, self.y = calcCoords(self)
	end,
	draw = function(self)
		love.graphics.setColor(self.color)
		love.graphics.setLineWidth(2)
		love.graphics.line(screen.width / 2, screen.height / 2, self.x, self.y)
	end,
}

return hands